use <voronoi.scad>

// Opening of your vent
ventopening = 40;
// Thickness of the material through which the vent goes
materialthickness = 18;
// Size of the border frame outside the vent
border = 5;
// Thickness of the walls
wallthickness = 3;
// Size of the ring that snaps the vent in place
snapringthickness = 1;
// Seed in case you want to have a specific pattern
seed =  undef;

rotate([180,0,0])
union () {
  difference() {
    cylinder(d=ventopening + border,h=wallthickness,center=true);
    translate([0,0,-2*wallthickness]) linear_extrude(5*wallthickness)
      random_voronoi(n = pow(ventopening/9,2), nuclei = false, L = ventopening, thickness = 2, round = 3, min = 0, max = 100, seed = seed, center = true);
  }
  difference() {
    cylinder(d=ventopening+2*border, h=wallthickness,center=true);
    cylinder(d=ventopening-wallthickness, h=wallthickness+1,center=true);
  }

  translate([0, 0, -0.5*(materialthickness+2*wallthickness)])
    difference() {
      union() {
        cylinder(d=ventopening, h=(materialthickness+2*wallthickness),center=true);
        translate([0,0,-0.5*(materialthickness+2*wallthickness)+0.5*wallthickness])
          cylinder(d2=ventopening,d1=ventopening+snapringthickness, h=wallthickness,center=true);
      }
      cylinder(d=ventopening-wallthickness, h=(materialthickness+2*wallthickness)+1,center=true);
      cube([2,ventopening+2*border,(materialthickness+2*wallthickness)+1],center=true);
      cube([ventopening+2*border,2,(materialthickness+2*wallthickness)+1],center=true);
    }


}
